import React, { Component } from 'react'
import fetch from 'isomorphic-fetch'
import { Store } from '../src'
import styles from './styles.icss'

/* eslint-disable no-console */

//	Dodgy fix for react key complaint
const keyFix = value => `key${value}`
let orderDescending = true

//	Our main component
class Formtest extends Component {

	constructor(props) {
		super(props)
		const me = this

		//	Set initial values of the store here
		this.store = new Store({
			list: ['l', 'o', 'a', 'd', 'i', 'n', 'g']
		},
		() => {
			/* eslint-disable no-underscore-dangle */
			if (me._isMounted) {
				me.forceUpdate()
			}
		})

		this.addItem = this.addItem.bind(this)
		this.bindSortBy = this.bindSortBy.bind(this)
	}

	componentDidMount() {
		/* eslint-disable no-underscore-dangle */
		this._isMounted = true

		//	Fetch the json
		fetch('examples/ipaddress-data.json').then(response => response.json()).then((json) => {
			this.store.set('list', json)
		})
	}

	componentWillUnmount() {
		this._isMounted = false
	}

	addItem() {
		const list = this.store.get('list')
		list.push({ id: (list.length + 1), first_name: 'Blinni', last_name: 'Shickle', email: 'bshickle8d@ucla.edu', gender: 'Female', ip_address: '140.149.139.146' })
		this.store.set('list', list)
	}

	bindSortBy(column, type) {
		const sorting = {
			numeric: (a, b) => b[column] - a[column],
			alpha: (avalue, bvalue) => {
				const a = avalue[column].toLowerCase()
				const b = bvalue[column].toLowerCase()
				let result = b > a ? 1 : -1
				if (b === a) {
					result = 0
				}
				return result
			},
			ip: (avalue, bvalue) => {
				const a = avalue[column].split('.')
				const b = bvalue[column].split('.')
				for (let i = 0; i < a.length; i += 1) {
					a[i] = parseInt(a[i], 10)
					b[i] = parseInt(b[i], 10)
					if (a[i] < b[i]) {
						return -1
					} else if (a[i] > b[i]) {
						return 1
					}
				}
				return 0
			}
		}
		const me = this
		return () => {
			const list = me.store.get('list')
			list.sort(sorting[type])
			orderDescending = !orderDescending
			if (!orderDescending) {
				list.reverse()
			}
			me.store.set('list', list)
		}
	}


	render() {
		return (
			<div className="route route__signup">
				<h1>Large table</h1>
				<p>
					This table contains 1000 records - click the header to sort
				</p>

				<div>
					<div className={styles.dataHeaderRow}>
						<span className={styles.id}><a role="button" tabIndex={-1} onClick={this.bindSortBy('id', 'numeric')}>ID</a></span>
						<span className={styles.first_name}><a role="button" tabIndex={-1} onClick={this.bindSortBy('first_name', 'alpha')}>First name</a></span>
						<span className={styles.last_name}><a role="button" tabIndex={-1} onClick={this.bindSortBy('last_name', 'alpha')}>Last name</a></span>
						<span className={styles.email}><a role="button" tabIndex={-1} onClick={this.bindSortBy('email', 'alpha')}>Email</a></span>
						<span className={styles.gender}><a role="button" tabIndex={-1} onClick={this.bindSortBy('gender', 'alpha')}>Gender</a></span>
						<span className={styles.ip_address}><a role="button" tabIndex={-1} onClick={this.bindSortBy('ip_address', 'ip')}>IP address</a></span>
					</div>
					{this.store.get('list') && this.store.get('list').length > 0 &&
						this.store.get('list').map((item, idx) => (
							<div className={styles.dataRow} key={keyFix(idx)}>
								<span className={styles.id}>{item.id}</span>
								<span className={styles.first_name}>{item.first_name}</span>
								<span className={styles.last_name}>{item.last_name}</span>
								<span className={styles.email}>{item.email}</span>
								<span className={styles.gender}>{item.gender}</span>
								<span className={styles.ip_address}>{item.ip_address}</span>
							</div>
						))
					}
				</div>

				<button type="button" onClick={this.addItem}>Add item</button>

			</div>
		)
	}
}

export default Formtest
