const calls = {}

const cache = async (func, key, value, duration = 5000) => {
	const hash = `key:${key}_value:${value}` // this can be pretty simple for our use case

	if (calls[hash] !== undefined) {
		return calls[hash].result
	}

	const result = await func(value)

	calls[hash] = {
		result,
		expire: setTimeout(() => {
			delete calls[hash]
		}, duration)
	}

	return result
}

export default cache
