import moment from 'moment'

// TODO: pass these in I guess..
const validDateFormats = [
	'YYYYMMDD',
	'YYYY-M-D',
	'YYYY-MMM-D',
	'D-M-YYYY',
	'D-MMM-YYYY',
	'YYYY/M/D',
	'YYYY/MMM/D',
	'D/M/YYYY',
	'D/MMM/YYYY',
	'YYYY M D',
	'YYYY MMM D',
	'D M YYYY',
	'D MMM YYYY',
	'YYYY.M.D',
	'YYYY.MMM.D',
	'D.M.YYYY',
	'D.MMM.YYYY'
]

const validDateTimeFormats = validDateFormats.reduce((acc, format) => [...acc,
	`${format} h:m:s`,
	`${format} h:m`,
	`${format} h:m:s a`,
	`${format} h:m a`
], [])

const datetimeExtension = ({
	parse: (value, options) => {
		const formats = options.dateOnly ? validDateFormats : validDateTimeFormats
		const result = +moment.utc(value, formats, true)
		return result
	},
	format: (value, options) => {
		const format = options.dateOnly ? 'YYYY-MM-DD' : 'YYYY-MM-DD hh:mm:ss'
		return moment.utc(value).format(format)
	}
})

export default datetimeExtension
